#ifndef SHROOMS_VB_NATIVE_WINDOW_
#define SHROOMS_VB_NATIVE_WINDOW_

#include <SDL2/SDL.h>
#include "nuklear.h"

#define MENU_HEIGHT 20

typedef struct WindowContext {
    SDL_Window *window;
    SDL_Renderer *renderer;
    SDL_Texture *leftEye;
    SDL_Texture *rightEye;
    struct nk_context *nk;
    struct nk_font *font;
} WindowContext;

int windowInit(WindowContext *win, const char *title);
void windowDestroy(WindowContext *win);

void windowUpdate(WindowContext *win, const uint8_t *left, const uint8_t *right);

int windowGetScreenHeight(WindowContext *win);

void windowDisplayBegin(WindowContext *win);
void windowDisplayEnd(WindowContext *win);
bool windowGuiBegin(WindowContext *win, const char *title);
void windowGuiEnd(WindowContext *win);
void windowMenubarBegin(WindowContext *win, const char **items);
void windowMenubarEnd(WindowContext *win);

#endif